boolean inBounds(int xx, int yy){
  return (xx>=0 && yy>=0 && xx<scrWidth && yy<scrHeight);
}

float distance(float x1, float y1, float x2, float y2){
  float dis = abs((x1 - x2)*(x1 - x2) + (y1 - y2)*(y1 - y2));
  return dis;
}

color adjustColor(color _in,int _r,int _g,int _b){
  color _newColor = color(red(_in)+_r,green(_in)+_g,blue(_in)+_b);
  return _newColor;
}

void plantShrooms(){
  for (int _i=0;_i<100;_i++){
    int _x=int(random(scrWidth));
    int _y=int(random(scrHeight));
    if(collisionMap.get(_x,_y)==WHITE || collisionMap.get(_x,_y)==POOP){
      if(countSurrounding(_x,_y,POOP, collisionMap) > 1 && countSurrounding(_x,_y,POOP, collisionMap)+countSurrounding(_x,_y,SHROOM, collisionMap) > 5){
        collisionMap.set(_x,_y,SHROOM);
      }
    }
    /*
    if(collisionMap.get(_x,_y)==POOP){
      int _x2=int(random(-3,3));
      int _y2=int(random(-3,3));
      if(inBounds(_x+_x2,_y+_y2)){
        if(collisionMap.get(_x+_x2,_y+_y2)==WHITE){
          collisionMap.set(_x+_x2,_y+_y2,SHROOM);
          collisionMap.set(_x,_y,WHITE);
        }
      }
    }*/
  }
}
void hatchEggs(){
  for (int _i=0;_i<43;_i++){
    int _x=int(random(scrWidth));
    int _y=int(random(scrHeight));
    if(collisionMap.get(_x,_y)==EGG){
      collisionMap.set(_x,_y,GROBBLING);
      mobs.add (new Mob(_x,_y,0));
    }
  }
}

void updatePotentialFields(){
  for (int _i=0;_i<250;_i++){
    int _x=int(random(scrWidth));
    int _y=int(random(scrHeight));
    
    if(collisionMap.get(_x,_y)==WATER){
      waterMap.set(_x,_y,WHITE);
    }else{
      int _avg = int(averagePixel(_x, _y, waterMap));
      waterMap.set( _x,_y, color(_avg));
    }
    if(collisionMap.get(_x,_y)==BLACK){
      waterMap.set(_x,_y,BLACK);
    }
    
    _x=int(random(scrWidth));
    _y=int(random(scrHeight));
    
    if(collisionMap.get(_x,_y)==SHROOM){
      foodMap.set(_x,_y,WHITE);
    }else{
      int _avg = int(averagePixel(_x, _y, foodMap));
      foodMap.set( _x,_y, color(_avg));
    }
    if(collisionMap.get(_x,_y)==BLACK){
      foodMap.set(_x,_y,BLACK);
    }
    /*
    _x=int(random(scrWidth));
    _y=int(random(scrHeight));
    
    if(collisionMap.get(_x,_y)==SHROOM){
      foodMap.set(_x,_y,WHITE);
    }else{
      int _avg = int(averagePixel(_x, _y, foodMap));
      foodMap.set( _x,_y, adjustColor(color(_avg),-1,-1,-1));
    }
    
    if(collisionMap.get(_x,_y)==BLACK && random(1)<0.3){
      foodMap.set(_x,_y,BLACK);
    }*/
    /*
    if(random(1)<0.00001){
      waterMap.loadPixels();
      //for(int _i=0;_i<
      
      //loadPixels();
      for (int i = 0; i < scrWidth*scrHeight; i++) {
       waterMap.pixels[i] =adjustColor(waterMap.pixels[i],-1,-1,-1);
      }
      waterMap.updatePixels();

    }
    */
  }
}

float averagePixel(int xx, int yy, PImage _img){
  float count=0;
  color _c;
  for(int tx = -1;tx<2;tx++){
    for(int ty = -1;ty<2;ty++){
      if(inBounds(xx+tx,yy+ty)){
        if (tx==0 && ty==0){
          //_c=color(0);
          _c=_img.get(xx+tx,yy+ty);
        }else{
          _c=_img.get(xx+tx,yy+ty);
        }
        
      }else{
        _c=color(0);
      }
      count+=brightness(_c);
      
    }
  }
  return count/9;
}


int countSurrounding(int xx, int yy, color compareWith, PImage _img){
  int count=0;
  for(int tx = -1;tx<2;tx++){
    for(int ty = -1;ty<2;ty++){
      if(inBounds(xx+tx,yy+ty)){
        if(_img.get((xx+tx),(yy+ty)) == compareWith){
          if (tx==0 && ty==0){
            //FUGDE
          }else{
            count++;
          }
        }
        
      }
    }
  }
  return count;
}
