void renderGame(){
  //image(background,0,0);
  buffer.copy(background,0,0,scrWidth,scrHeight,0,0,scrWidth,scrHeight);
  //buffer.copy(background);
  color _tColor;
  for(int _y=0;_y<scrWidth;_y++){
    for(int _x=0;_x<scrWidth;_x++){
      _tColor = collisionMap.get(_x,_y);
      if(_tColor == WHITE){
        buffer.set(_x,_y,adjustColor(background.get(_x,_y),-50,-45,-40));
      }
      if(_tColor == WATER){
        buffer.set(_x,_y,adjustColor(background.get(_x,_y),-30,-25,+40));
      }
      if(_tColor == SHROOM){
        buffer.set(_x,_y,SHROOM);
      }
      if(_tColor == BOMB){
        buffer.set(_x,_y,BOMB);
      }
      if(_tColor == EGG){
        buffer.set(_x,_y,EGG);
      }
      if(_tColor == POOP){
        buffer.set(_x,_y,POOP);
      }
      if(_tColor == BLACK && collisionMap.get(_x,_y+1)==WHITE){
        buffer.set(_x,_y,adjustColor(background.get(_x,_y),+50,+40,0));
      }
      if(collisionMap.get(_x,_y)==GROBBLING){
        buffer.set(_x,_y,adjustColor(GROBBLING,-80,-70,-40));
        buffer.set(_x,_y-1,adjustColor(GROBBLING,10,-20,10));
      }
    }
  }
  image(buffer,0,0);
  if(showWaterTrail){image(waterMap,0,0);}
  if(showFoodTrail){image(foodMap,0,0);}
  if(showCollision){image(collisionMap,0,0);}
  //text(brightness(waterMap.get(int(mouseX*.25),int(mouseY*.25))),10,10);
  text("GROBBLINGS: " + grobblingCounter,scrWidth*0.5,10);
  
  
  for (int i = anims.size()-1; i >= 0; i--) { // go through all the anims
    multiAnimObject _anim = (multiAnimObject) anims.get(i);
    _anim.display(_anim.xpos,_anim.ypos);
    
    if (_anim.finished) { // Items can be deleted with remove() from ArrayList.
      anims.remove(i);
    }
  }
  //tint(255,20);
  //image(collisionMap,0,0);
  //image(collisionMap,0,-1);
}
